<?php
/*
Plugin Name: Elfsight Facebook Chat CC
Description: Add to your site a fast and seamless communication tool for your users.
Plugin URI: https://elfsight.com/facebook-chat-widget/codecanyon/?utm_source=markets&utm_medium=codecanyon&utm_campaign=facebook-chat&utm_content=plugin-site
Version: 1.1.0
Author: Elfsight
Author URI: https://elfsight.com/?utm_source=markets&utm_medium=codecanyon&utm_campaign=facebook-chat&utm_content=plugins-list
*/

if (!defined('ABSPATH')) exit;


require_once('core/elfsight-plugin.php');

$elfsight_facebook_chat_config_path = plugin_dir_path(__FILE__) . 'config.json';
$elfsight_facebook_chat_config = json_decode(file_get_contents($elfsight_facebook_chat_config_path), true);

new ElfsightFacebookChatPlugin(
    array(
        'name' => esc_html__('Facebook Chat'),
        'description' => esc_html__('Add to your site a fast and seamless communication tool for your users.'),
        'slug' => 'elfsight-facebook-chat',
        'version' => '1.1.0',
        'text_domain' => 'elfsight-facebook-chat',
        'editor_settings' => $elfsight_facebook_chat_config['settings'],
        'editor_preferences' => $elfsight_facebook_chat_config['preferences'],
        'script_url' => plugins_url('assets/elfsight-facebook-chat.js', __FILE__),

        'plugin_name' => esc_html__('Elfsight Facebook Chat'),
        'plugin_file' => __FILE__,
        'plugin_slug' => plugin_basename(__FILE__),

        'vc_icon' => plugins_url('assets/img/vc-icon.png', __FILE__),

        'menu_icon' => plugins_url('assets/img/menu-icon.svg', __FILE__),
        'update_url' => esc_url('https://a.elfsight.com/updates/v1/'),

        'preview_url' => plugins_url('preview/preview.html', __FILE__),
        'observer_url' => plugins_url('preview/facebook-chat-observer.js', __FILE__),

        'product_url' => esc_url('https://codecanyon.net/item/facebook-chat-wordpress-facebook-chat-plugin/23878195?ref=Elfsight'),
        'support_url' => esc_url('https://elfsight.ticksy.com/submit/#100015319')
    )
);

?>
